
graintrailer = {};

function graintrailer.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function graintrailer:load(xmlFile)

	-- Mi ricavo il nodo associato alla copertura
    self.plane = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plane#index"));

	-- Recupero tasti da xml
	self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;

	-- Posizione del hud della immagine
    self.hudTrailerPoxX = 0.8325;
    self.hudTrailerPoxY = (1-0.62);
    self.hudTrailerWidth = 0.16;
    self.hudTrailerHeight = 0.165;

	self.helpPanel = true;
	self.attached = true;
	self.planeActive = true;
	self.istrailer1 = false;
end;

function graintrailer:delete()
end;

function graintrailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function graintrailer:keyEvent(unicode, sym, modifier, isDown)

	if self.attached then
		if isDown and sym == self.keys.PLANE1 then
			trailer.planeActive = not trailer.planeActive;
		end;
	end;

end;

function graintrailer:update(dt)

	if g_currentMission.currentVehicle ~= nil then
		for i=1, table.getn(g_currentMission.currentVehicle.attachedImplements) do
			if g_currentMission.currentVehicle.attachedImplements[i].object then
				-- In trailer ci sono i dati del primo rimorchio
				local trailer = g_currentMission.currentVehicle.attachedImplements[i].object;

				if trailer.planeActive then
					local plane = trailer.plane;
					setVisibility(plane);
				else
					local plane = trailer.plane;
					setVisibility(plane, false);
				end;
			end;
		end;
	end;
end;


function graintrailer:draw()

	if self.rimorchio1 then
		g_currentMission:addExtraPrintText("Tarp "..key_convert(self.keys.PLANE1)..": Copertura rimorchio 1");
	end;


	if g_currentMission.currentVehicle ~= nil then
		for i=1, table.getn(g_currentMission.currentVehicle.attachedImplements) do
			if g_currentMission.currentVehicle.attachedImplements[i].object and g_currentMission.currentVehicle.attachedImplements[i].object.isSelected then
				trailer = g_currentMission.currentVehicle.attachedImplements[i].object;
				self.attached = true;
			end;
		end;
	end;
    for i=1, table.getn(self.attachedImplements) do
        if self.attachedImplements[i].object and self.attachedImplements[i].object.isSelected then
			trailer1 = self.attachedImplements[i].object;
			self.attached = false;
			self.istrailer1 = true;
		end;
	end;

	-- Settaggio stile caratteri
	setTextBold(true);
	setTextColor(1.0, 1.0, 1.0, 1.0);

	-- stampa a video del men
	if self.attached then
		renderText(self.hudTrailerPoxX, self.hudTrailerPoxY+0.39, 0.025, " Grain Trailer ");
		renderText(self.hudTrailerPoxX+0.042, self.hudTrailerPoxY+0.36, 0.025, "- Info -");

		if trailer.planeActive then
			renderText(self.hudTrailerPoxX+0.001, self.hudTrailerPoxY+0.34, 0.02, "Tarp "..key_convert(self.keys.PLANE1)..": Tarp 1 open");
		else
			renderText(self.hudTrailerPoxX+0.001, self.hudTrailerPoxY+0.34, 0.02, "Tarp "..key_convert(self.keys.PLANE1)..": Tarp 1 close");
		end;

	end;
end;

function key_convert(key)
	if key < 256 then
		return string.upper(""..string.char(key).."");
	elseif key > 255 and key < 266 then
		return string.upper("KP"..string.char(key-208));
	else
		return "n/a";
	end;
end;
